Leetcode hot100 旋转图像【中等】

凭直觉,很自然想到写个while循环由外向内一圈一圈弄,再想每一圈怎么弄。每一圈怎么弄,也是靠直觉。比如下面这个矩阵。

1 2 3 4 4

4 5 6 4 4

7 8 9 4 4

1 1 1 1 4

4 4 4 4 4

以最外圈举例,最外圈要这样走一遍,就能完成旋转。

====================================================

好了,思路有了,现在开始写代码了。

首先,直觉告诉我,每一圈的最左上角的元素,由于是(0,0)、(1,1)、(2,2)这种既能用来表示这是第几圈,又能用来判断是否走到最后一圈,同时横坐标和纵坐标还一样,具有这么多特性,那我必须得维护这个参数啊。由于是每一圈的起点位置,所以我管他叫start。

初始化,第一圈的时候 int start=0;

然后我们开始想退出while循环的条件:如果正方形的长度是奇数,那么最后剩一个元素,如果正方形的长度是偶数,那么最后一圈没有元素。我隐隐约约感受到,可以用start和矩阵长度之间的关系去判断。当起点(start,start)坐标到了长度n的一半的时候,就该退出了,具体是小于号还是小于等于号,列几个情况去分析一下。

每一圈的旋转咋写呢?首先要确定每一圈要转几个元素。

最外圈需要动4个元素,图中红框框出的这4个:

再往里一圈需要动2个元素,图中绿框框出的这2个:

分析一下,得到需要转动的元素个数int num=n-2*start-1;

接下来我们就要找每个元素旋转的规律了。先把所有元素的旋转先写下来,找规律,只需要写两圈的,就能看出来规律。

最外圈,start=0,num=4:

(0,0)<-(4,0)<-(4,4)<-(0,4)<-(0,0)

(0,1)<-(3,0)<-(4,3)<-(1,4)<-(0,1)

(0,2)<-(2,0)<-(4,2)<-(2,4)<-(0,2)

(0,3)<-(1,0)<-(4,1)<-(3,4)<-(0,3)

倒数第二圈:start=1,num=2

(1,1)<-(3,1)<-(3,3)<-(1,3)<-(1,1)

(1,2)<-(2,1)<-(3,2)<-(2,3)<-(1,2)

竖着看,我在图里写了几个,你找找感觉:

找到感觉后,整个规律就出来了:

matrix**startstart+i** <- matrixstart+num-istart <- matrix**start+numstart+num-i**<-matrixstart+i start+num** <- matrixstartstart+i**

还有一个视角,更快出规律,先用4个角去写:

start\]\[start\]**\<-** \[start+num\]\[start\]**\<-** \[start+num\]\[start+num\] **\<-** \[start\]\[start+num\]**\<-**\[start\]\[start

↓这是第0个,再考虑如何迁移到下一个(第i个)------行数如何变,列数如何变?

matrixstartstart****+i**** <- matrixstart+num****-i****start <- matrixstart+numstart+num****-i**** <-matrixstart****+i**** start+num <- matrixstartstart****+i****

java 复制代码
class Solution {
    public void rotate(int[][] matrix) {
        int n = matrix.length;
        //特殊情况
        if(n==1) return;

        int start=0;
        // n=3 start=1停下
        // n=4 start=2停下
        // n=5 start=2停下
        // n=6 start=3停下
        //由外到内一圈一圈的搞,直到最内圈是长度为1的小正方形,或者长度为0,停下
        while(start<n/2){
            // start=0,循环n-1次
            // start=1,循环6-(2start)-1次
            // start=2 循环1次 6-(2start)-1次
            int num=n-2*start-1;  //这一轮每一行有多少个要旋转的元素

            for(int i=0; i<num; i++){
                
                int temp=matrix[start][start+i];
                matrix[start][start+i]=matrix[start+num-i][start];
                matrix[start+num-i][start]=matrix[start+num][start+num-i];
                matrix[start+num][start+num-i]=matrix[start+i][start+num];
                matrix[start+i][start+num]=temp;
            }
            
            start++;//下一圈的起点是(start,start)
        }

    

     
    }
}
相关推荐
信奥卷王几秒前
[GESP202509 六级] 货物运输(含视频)
算法
余额瞒着我当琳24 分钟前
C++算法学习篇5--二分查找法
c++·学习·算法
起个名字费劲死了35 分钟前
基于灰度/形状的2D模板匹配
算法
杜 硕41 分钟前
归并排序详解
数据结构·算法·排序算法
科技观察哨1 小时前
国产纳米定位平台与精密位移台量产能力图谱(2026):Z轴压电、XYθZ、六自由度并联与光刻/检测/装配选型指南
网络·人工智能·算法
AIHR数智引擎2 小时前
蚂蚁350亿换不来智能体飞轮?拆中台和流水线
人工智能·经验分享·职场和发展·ai-native·aihr
鶴哥只手遮天2 小时前
《OpenFOAM 源码深度剖析》系列-第 3 章 字典系统、IO 体系与对象注册表
算法·开源
鶴哥只手遮天2 小时前
《OpenFOAM 源码深度剖析》系列-第 2 章 wmake:OpenFOAM 自研构建系统与编译配置体系
算法·开源
用户81849100742162 小时前
我把工位上的“AI牛马”养成了:一个技术人的 AiPy 实战手记
算法
Tisfy2 小时前
LeetCode 3727.最大交替平方和:排序 (双指针可选)
算法·leetcode·题解·贪心·数组·排序